
import numpy as np 


class pipeline():
    def __init__(self, classifier, regressor, threshold=.5):
        self.classifier = classifier
        self.regressor = regressor
        self.threshold = threshold
    
    def predict(self, X):
        
        classifier_pred = self.classifier.predict(X).flatten()

        classifier_pred_threshold = np.array([0 if _ <=self.threshold else 1 for _ in classifier_pred])

        pred = classifier_pred_threshold.copy()

        non_zero_list = classifier_pred_threshold==1

        #non_zero = X[non_zero_list]

        try:
        
            regressor_pred = self.regressor.predict(X).flatten()

            #pred[non_zero_list] = regressor_pred[non_zero_list]
            
            pred = np.where(non_zero_list, regressor_pred, pred)
            
        except:
            print('Error')
            pred = pred

        return pred
